# CA1-DAAA2B04-p2100733-ella

Author : Ella
S/N : p2100733
Class : DAAA/FT/2B04


## Getting started

To make it easy for you to get started with GitLab, here's a list of recommended next steps.

Already a pro? Just edit this README.md and make it your own. Want to make it easy? [Use the template at the bottom](#editing-this-readme)!

## Add your files

- [ ] [Create](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#create-a-file) or [upload](https://docs.gitlab.com/ee/user/project/repository/web_editor.html#upload-a-file) files
- [ ] [Add files using the command line](https://docs.gitlab.com/ee/gitlab-basics/add-file.html#add-a-file-using-the-command-line) or push an existing Git repository with the following command:

```
cd existing_repo
git remote add origin https://gitlab.com/2b04.2100733.woonel/ca1-daaa2b04-p2100733-ella.git
git branch -M main
git push -uf origin main
```

## Integrate with your tools

- [ ] [Set up project integrations](https://gitlab.com/2b04.2100733.woonel/ca1-daaa2b04-p2100733-ella/-/settings/integrations)

## Collaborate with your team

- [ ] [Invite team members and collaborators](https://docs.gitlab.com/ee/user/project/members/)
- [ ] [Create a new merge request](https://docs.gitlab.com/ee/user/project/merge_requests/creating_merge_requests.html)
- [ ] [Automatically close issues from merge requests](https://docs.gitlab.com/ee/user/project/issues/managing_issues.html#closing-issues-automatically)
- [ ] [Enable merge request approvals](https://docs.gitlab.com/ee/user/project/merge_requests/approvals/)
- [ ] [Automatically merge when pipeline succeeds](https://docs.gitlab.com/ee/user/project/merge_requests/merge_when_pipeline_succeeds.html)

## Test and Deploy

Use the built-in continuous integration in GitLab.

- [ ] [Get started with GitLab CI/CD](https://docs.gitlab.com/ee/ci/quick_start/index.html)
- [ ] [Analyze your code for known vulnerabilities with Static Application Security Testing(SAST)](https://docs.gitlab.com/ee/user/application_security/sast/)
- [ ] [Deploy to Kubernetes, Amazon EC2, or Amazon ECS using Auto Deploy](https://docs.gitlab.com/ee/topics/autodevops/requirements.html)
- [ ] [Use pull-based deployments for improved Kubernetes management](https://docs.gitlab.com/ee/user/clusters/agent/)
- [ ] [Set up protected environments](https://docs.gitlab.com/ee/ci/environments/protected_environments.html)

***

## Features from Topicals to be included into Assignment

Jinja2

- [ ] [Condition-if]
- [ ] [Loops]
- [ ] [With]
- [ ] [Marcos]
- [ ] [Import]

Flask-SQLAlchemy CRUD

- [ ] [Add]
- [ ] [Read Entries]
- [ ] [Read Entry]
- [ ] [Read with Filtering Entry]
- [ ] [Update]
- [ ] [Deletion]

WTForms - Validation 

- [ ] [DataRequired]
- [ ] [Length]
- [ ] [NumberRange]
- [ ] [Email]
- [ ] [URL]
- [ ] [AnyOf]
- [ ] [NoneOf]

WTForms - Image Uploads

- [ ] [Image Upload]

Deployment 

- [ ] [Automating deployment using Gitlab]
- [ ] [Use Nginx to server website]
- [ ] [Gunicorn]

Unit Test
## Name
Choose a self-explaining name for your project.

- [ ] [Add]
- [ ] [Read Entries]
- [ ] [Read Entry]
- [ ] [Read with Filtering Entry]
- [ ] [Update]
- [ ] [Deletion]

WTForms - Validation 

- [ ] [DataRequired]
- [ ] [Length]
- [ ] [NumberRange]
- [ ] [Email]
- [ ] [URL]
- [ ] [AnyOf]
- [ ] [NoneOf]

WTForms - Image Uploads

- [ ] [Image Upload]

Deployment 

- [ ] [Automating deployment using Gitlab]
- [ ] [Use Nginx to server website]
- [ ] [Gunicorn]

Unit Test
- [ ] [Subset By Matching String]
- [ ] [Grouping tests together]
- [ ] [Parameterisation]
